<template lang="pug">
b-card( :title='`Группа "${name}"`' )
	group-form( v-if='group' v-model='formatedGroup' :loading='pending' :edit='true' @submit='submit' )
</template>

<script setup>
import GroupForm from "@/components/group/GroupForm.vue";

import { computed, onMounted, ref, watch } from "vue"

import { useGroupStore } from "@/stores/group"
import { useRoute, useRouter } from "vue-router"
import { useToast } from "vue-toastification"

const gs = useGroupStore()
const $route = useRoute()
const $router = useRouter()
const toast = useToast()

const group = ref(null)
const pending = ref(false)

const formatedGroup = computed({
	get: () => ({
		name: group.value?.name,
		clients: group.value?.clients.map(client => {
			if (typeof client == "object")
				return client.id
			
			return client
		})
	}),
	set: val => group.value = val
})
const id = computed(() => $route.params.id)
const name = computed(() => group.value?.name || "...")

const fetch = async () => {
	if (!id.value) return

	try {

		const data = await gs.getGroup(id.value)

		if (!data) return $router.back()

		group.value = data
	} catch(err) {
		console.error(err)
		if (err.response?.status && err.response.status == 404)
			return $router.back()
	}
}

const submit = async () => {
	try {
		if (pending.value) return
		if (!group.value.name) return toast.warning("Вы не заполнили название группы")
	
		pending.value = true
		await gs.editGroup(id.value, group.value)
		pending.value = false
		toast.success("Изменения сохранены")
	} catch(err) {
		pending.value = false
		console.error(err)
	}
}

watch(id, fetch)
onMounted(fetch)
</script>